#!/bin/sh

# Test for Perl existence
PERLPATH=`which perl 2>/dev/null`
if [ $? = "127" ]; then
        echo "'which' utility is not installed. Installation aborted."
        exit 1
fi
if [ -z "$PERLPATH" ]; then
	echo "Perl is not installed. Installation aborted."
	exit 1
fi

# Check Perl version
if ! perl -e 'require 5.0' 2>/dev/null; then
	echo "You should install Perl 5.0 or greater. Installation aborted."
	exit 1
fi

[ -n `which dirname` ] && cd `dirname $0`
perl setup/install.pl
