
/*  
 * $Id: utils.c,v 1.10 2005/04/28 12:07:10 isv Exp $
 *
 * This source file is a part of a Kaspersky Antivirus Monitor.
 * Copyright (C) Kaspersky Lab, 1997-2004
 * See License.txt for details
 *
 */

#include "module.h"

/*
 * Code based on code from Dazuko project version 2.0.1 
 * Looking for the syscall table address if it is not exported
 * 
 */
  
#if defined(HIDDEN_SCT)

#ifdef NO_SYS_CLOSE
unsigned long sys_close_ = SYS_CLOSE_ADDR;
#else
unsigned int sys_close_ = (unsigned long )sys_close;
#endif




void ** get_sys_call_table_addr(void)
{
	unsigned long	ptr;
	extern int	loops_per_jiffy;
	unsigned long	*p;

	for (ptr=(unsigned long)&loops_per_jiffy ; ptr<(unsigned long)&boot_cpu_data ; ptr+=sizeof(void *))
	{
		p = (unsigned long *)ptr;
		if (p[6] == sys_close_)
		{
			return (void **)p;
		}
	}

	return NULL;
}
#endif


