#!/bin/sh
TEMP='/tmp/vox-'$$
SPWD=`pwd`
KAVSCANNER="/opt/kav/5.5/kav4unix/bin/kavscanner"
CONF="/etc/kav/5.5/kav4unix/kav4unix.conf"
name="$1"
suf=${name##*.}
bname=${name##/*/} 
sname=${bname%%.*}

if [ ! -d $TEMP ]; then
    mkdir -p $TEMP
fi

## tar 

if [ "$suf" = 'gz' -o "$suf" = 'tgz' ] ; then

    list=`tar -ztf $name`
    tar -C $TEMP -zxf $name
    $KAVSCANNER -c $CONF -i3 $TEMP
    cd $TEMP
    tar -czf $sname.tgz *
    for i in $list
	do
	    j=${i##/*/}
	    rm $j
	done

    mv $TEMP/$sname.tgz $SPWD/$sname.tgz.cure
    rm -rf $TEMP

## zip

elif [ "$suf" = 'zip' ] ; then
    
    unzip $name -d $TEMP
    $KAVSCANNER -c $CONF -i3 $TEMP
    cd $TEMP
    zip $sname.zip -r .
    mv $TEMP/$sname.zip $SPWD/$sname.zip.cure
    rm -rf $TEMP

## rar

elif [ "$suf" == 'rar' ] ; then
    
    rar x $name $TEMP
    $KAVSCANNER -c $CONF -i3 $TEMP
    cd $TEMP
    zip $sname.rar -r .
    mv $TEMP/$sname.rar $SPWD/$sname.rar.cure
    rm -rf $TEMP
    
fi
