package appdata;

use klinstall;

# This line should be modified by installer
my $MODE_MAILSERVER = 0; # fs,ws

# Set up application ID
my $APPID = $MODE_MAILSERVER ? 1135 : 1136;

my $KAVKASROOT = "/var/db/kav/savedsettings/v1";

############################## text strings ##################################
my $SETUPMSG_1 = <<MSG_END;
Set up mail server anti-virus protection.

The Installer has found this mail server installed on your computer:
Mail server: %1
Mail server binary path: %2
Mail server configuration file: %3

Please enter 'Y' to confirm that you want to protect this mail server with Kaspersky Anti-Virus. Enter 'N' if mail server has been detected incorrectly, or if you do not want to protect it.
MSG_END

my $SETUPMSG_2 = <<MSG_END;
Set up mail server anti-virus protection.

Setup was unable to detect an existing installation of a mail server on your computer. Either it is not installed or has been installed to an unknown location.
If it has been installed, and you know the installation details, enter 'Y'. Otherwise enter 'N' (configuration will be aborted):
MSG_END

my $SETUPMSG_3 = <<MSG_END;
Once you have installed and configured the mail server, you can run the configuration script again by running <B>%1</B>.
MSG_END

my $SETUPMSG_4 = <<MSG_END;
What mail server are you using (sendmail, qmail, postfix, exim)
MSG_END

my $SETUPMSG_5 = <<MSG_END;
Please enter the full path (without the filename) to your %1 binary %2
MSG_END

my $SETUPMSG_6 = <<MSG_END;
Please enter the full path to your %1 configuration file %2
MSG_END

my $SETUPMSG_7 = <<MSG_END;
Could not modify Kaspersky Anti-Virus for mail servers configuration file: %1.
You should set up the ForwardMailer option manually.
MSG_END

my $SETUPMSG_8 = <<MSG_END;
Kaspersky Anti-Virus for mail servers has successfully configured anti-virus protection for your %1. To activate it, you must start your %1 with <B>%2</B>.
Note that if you ignore this and do not start %1 with this script, your server WILL NOT be protected. Be careful!
MSG_END

my $SETUPMSG_9 = <<MSG_END;
Kaspersky Anti-Virus for mail servers has successfully configured anti-virus protection for your Postfix mail server. To activate it, you must restart Postfix.
MSG_END

my $SETUPMSG_10 = <<MSG_END;
Kaspersky Anti-Virus for mail servers has successfully configured anti-virus protection for your qmail.
MSG_END

my $SETUPMSG_11 = <<MSG_END;
Warning: the 'aveserver' component could not be started. Until it is running, it is not safe to configure mail server anti-virus protection. For security reason, the mail server with antivirus protection enabled will not accept incoming mail when aveserver is not running. Therefore, after the mail server is configured, it will stop receiving new mail until you start aveserver.

Before setting up anti-virus protection for your mail server, we suggest to solve the aveserver startup problems. You can do this by installing license files, updating anti-virus databases or fixing the file/directory permissions. Please check /var/log/kav/5.5/kav4mailservers/aveserver.log file for error messages. Only then it is safe to configure mail server protection.

Do you still want to ignore this warning, and set up the mail server anti-virus protection right now?
MSG_END

my $LICENSEMSG_1 = <<MSG_END;
Both traffic-based and per-user license files are found. What license type do you want to use (enter 'user' or 'traffic')
MSG_END

my $LICENSEMSG_2 = <<MSG_END;
License note: your user list %1 is not empty. Kaspersky Anti-Virus 5.5 does not require you to create and maintain the list of licensed users manually anymore. Instead it will be maintained automatically. Please read the documentation.
MSG_END

my $LICENSEMSG_3 = <<MSG_END;
To protect your users, and to apply automatic accounting of the license information, please enter the comma-separated list of the licensed mail domains. You should use shell masks (with ?, * and [] characters); check the documentation for details. Note that by default, * mask will be used, which will mean that ANY mail domain is licensed.
Examples: avp\\.ru,*\\.us[12345]\\.kaspersky\\.com

MSG_END

my $IMPORTMSG_1 = <<MSG_END;
Setup has found the existing %1 configuration file at %2. Do you want to import the settings to the v5.5 configuration file?
MSG_END

my $IMPORTMSG_2 = <<MSG_END;
Your settings from version 5.0.3.x have been successfully imported to the v5.5 configuration file. Your anti-virus databases and license files have also been copied. Please review the new configuration file at %1.
The default configuration file has been copied to %2.
MSG_END

my $IMPORTMSG_3 = <<MSG_END;
Warning: ExtraWgetOptions is set to '%1'
The new keepup2date component no longer uses wget, and therefore the ExtraWgetOptions setting will not work. Please correct your configuration file manually, as needed.
MSG_END

my $IMPORTMSG_4 = <<MSG_END;
Your settings from version 5.0 have been imported successfully to the v5.5 configuration file. The default configuration file has been copied to %2. Your anti-virus databases and license files also have been copied.

Note that the executable name, the settings, and the behavior of kavupdater component have been completely changed. Most components also contain significant changes. Please read the documentation about the changes (especially if you previously routinely updated from the local server). The default behavior is set to update through the Internet. Please examine the new configuration file at %1, and make all necessary changes.
MSG_END

my $IMPORTMSG_5 = <<MSG_END;
Some of your settings from version 4.0 have been imported successfully to the v5.5 configuration file stored as %1. Your anti-virus databases and license files also have been copied.

Note that the executable names, the settings, and the behavior of all the components have been changed. Therefore it is impossible to completely retain all of your settings, especially in more complicated cases. Please read the documentation about the changes.
Please review the configuration file created at %1, make all necessary changes and copy it to %2.
MSG_END


my $UNINSTALL_MSG_1 = <<MSG_END;
Uninstallation aborted: you must stop the Kaspersky Anti-Virus On-Access Scanner (kavmonitor) before uninstalling Kaspersky Anti-Virus for Unix.
MSG_END

my $UNINSTALL_MSG_2 = <<MSG_END;
the file %1 has been modified since the installation of %2. Because it is not possible to merge or replace these modifications automatically, it should be done manually. Your modified file is saved as %3, and the old file (dated %4) is restored in its place.
MSG_END

my $UNINSTALL_MSG_3 = <<MSG_END;
the file %1 created during installation of %2, has been modified. Because it is not possible to merge these modifications into the working configuration automatically, it should be done manually. Your modified file is saved as %3.
MSG_END

my $SECURITY_CHECK_MSG_1 = <<MSG_END;

<B>Warning:</B> some files/directories have insecure permissions.
This is a big security risk. It leads to known <B>local root exploit</B> if any malicious user has access to this computer. We suggest to fix it by changing the permissions to 775 (or 770). Unfortunately that after the fix, you will not be able to run keepup2date from non-root user anymore.
Answer 'Y' if you want fix the permissions now, 'N' if you want to left them intact, and '?' to see the list of directories and permissions/owners to be changed.
MSG_END


my $KLUSER = "kluser";
my $KLGROUP = "klusers";

# every module should return true to be loaded successfully
return 1;

# Returns application information.
#
# Should define at least these hash values:
#
my %APPINFO_CACHE;
sub get_application_info
{
	# Take install data
	if ( !%APPINFO_CACHE )
	{
		my %AI;
		seek (DATA, 0, 0);
		foreach (<DATA>)
		{
			chomp;
			m/^f\s+(.*)$/ and $AI{"FILES"} .= "$1\n"
				or m/^d\s+(.*)$/ and $AI{"DIRS"} .= "$1\n"
					or m/^(\w+)=(.*)$/ and $AI{$1} = $2;
		}

		klinstall::fatal ("Corrupted installation!") 
			if !$AI{"INSTROOT"};

		$AI{"INSTROOT"} =~ s/\/$//; # remove trailing slash

		$AI{"ID"} = $APPID;
		$AI{"VER"} = "5.5.0";

		$AI{"NAME"} = $MODE_MAILSERVER
				? "Kaspersky Anti-Virus for Mail Servers" 
				: "Kaspersky Anti-Virus for Unix";

		my $pathcomp = $MODE_MAILSERVER ? "kav4mailservers" : "kav4unix";
		$AI{"DEFAULT_CONFIG"} = "/etc/kav/5.5/$pathcomp/$pathcomp.conf";
		$AI{"PATH_BASES"} = "/var/db/kav/5.5/$pathcomp/bases";
		$AI{"PATH_LICENSES"} = "/var/db/kav/5.5/$pathcomp/licenses";

		$AI{"REQUIRE_AV_BASES"} = "1";
		$AI{"REQUIRE_SETUP_KEEPUP2DATE"} = "1";
		$AI{"REQUIRE_LICENSES"} = "1";

		$AI{"TXT_WRTUAB"} = "keepup2date component";
		$AI{"TXT_WRTIL"}  = "$AI{INSTROOT}/bin/licensemanager -a <keyfile>";

		$AI{"COMP_WEBMIN_MODULE"} = "$AI{INSTROOT}/contrib/" . ($MODE_MAILSERVER ? "kavms.wbm" : "kavfs.wbm");
		$AI{"COMP_SETUP_SCRIPT"}  = "$AI{INSTROOT}/setup/setup.pl";
		$AI{"COMP_POSTINSTALL_SCRIPT"} = "$AI{INSTROOT}/setup/postinstall.pl";

		# Internally used
		$AI{"PATH_SMTPSCAN"} = "$AI{INSTROOT}/bin/smtpscanner";
		$AI{"PATH_QMAILQUE"} = "$AI{INSTROOT}/bin/qmail-queue";
		$AI{"PATH_LICMANAGER"} = "$AI{INSTROOT}/bin/licensemanager";
		$AI{"PATH_KEEPUP2DATE"} = "$AI{INSTROOT}/bin/keepup2date";
		$AI{"PATH_CONV40SCRIPT"} = "$AI{INSTROOT}/setup/convertsettings40to50.pl";

		%APPINFO_CACHE = %AI;
	}

	my %aicopy = %APPINFO_CACHE;
	return %aicopy;
}

# Generic checks
sub app_check_os_ver { return 0; }
sub app_check_linux_distro { return 0; }
sub app_get_conflict_ids { return; }
sub app_check_required_components { return; }

sub app_check_optional_components
{
	# Create kluser/klusers if absent
	my $shell = -f "/sbin/nologin" ? "/sbin/nologin" : "/bin/false";

	klinstall::add_group ($KLGROUP) or return $@;
	klinstall::add_user ($KLUSER, $KLGROUP, $shell, "/var/db/kav") or return $@;
	return;
}


sub app_start
{
	return;
}


sub app_stop
{
	return;
}


sub app_checks_preuninstall
{
	if ( !$MODE_MAILSERVER )
	{
		return $UNINSTALL_MSG_1 if klinstall::get_process_pids("kavmonitor");
	}

	return;
}


sub app_is_license_needed
{
	my %AI = get_application_info();
	my $lictool = $AI{"PATH_LICMANAGER"};

	# Test whether the valid key file is already installed
	my ($rc, $msg) = klinstall::exec_cmd_as_user ($KLUSER, "$lictool", "-s");
	return $rc == 0 ? 0 : 1;
}


sub install_licenses
{
	my $licpath = shift;
	my %AI = get_application_info();
	my $lictool = $AI{"PATH_LICMANAGER"};

	opendir LICDIR, $licpath or return "Could not open directory $licpath: $!";
	my @keyfiles = grep { /\.key$/i && -f "$licpath/$_" } readdir (LICDIR);
	closedir LICDIR;

	return "No license files (files with .key extension) were found in the directory '$licpath'."
		if !@keyfiles;

	# Check all the key files for validity
	my (%validkeys, @errormsgs);

	foreach (@keyfiles)
	{
		# Check whether it is a KL key file and is valid
		my ($rc, $msg) = klinstall::exec_cmd_safe ($lictool, "-q", "-k", "$licpath/$_");

		if ( !defined $rc || ( $rc & 127 ) )
		{
			klinstall::output ("Could not execute licensemanager: $msg\n");
			next;
		}

		$rc >>= 8;

        $rc != 0 and push @errormsgs, "$_ rejected - not a valid Kaspersky Lab license file."
        	or $msg !~ /\bALLOWED=yes\b/ and push @errormsgs, "$_ rejected - not valid for this product."
        		or $validkeys{"$licpath/$_"} = $msg;
	}

	if ( !%validkeys )
	{
		klinstall::output ("\n" . join ("\n", @errormsgs));
		return "None of the Kaspersky Lab license files found is valid for this product.";
	}

	# Recheck all the keys, and generate warnings
	if ( $MODE_MAILSERVER )
	{
		my ($users, $traffic) = (0, 0);
		foreach (keys %validkeys)
		{
			next if $validkeys{$_} !~ /^LICENSE_TYPE\s*=\s*(\w+)$/m;
			my $lictype = $1;

			$users = 1 if $lictype =~ /user/i;
			$traffic = 1 if $lictype =~ /traffic/i;
		}

		# Ask the license type if ambiguous
		while ( $users && $traffic )
		{
			my $type = klinstall::ask_question ("KAVMS_SETUP_LICENSE_AMBIGUOUS", "user", $LICENSEMSG_1);
			$traffic = 0 if $type =~ /^user/;
			$users = 0 if $type =~ /^traffic/;
		}

		klinstall::output ($LICENSEMSG_2) if -s "$AI{PATH_LICENSES}/users";
		my $lictype = $traffic ? "traffic" : "users";
	
		klinstall::warning ("Could not set up license type to $lictype: ", klinstall::get_ini_error())
			if !klinstall::update_ini_file ( $AI{"DEFAULT_CONFIG"}, "smtpscan.license", ("LicenseType" => $lictype) );

		my $licdomains = klinstall::ask_question ("KAVMS_SETUP_LICENSE_DOMAINS", "*", $LICENSEMSG_3);
		klinstall::warning ("Could not set up license domains to $licdomains: ", klinstall::get_ini_error())
			if !klinstall::update_ini_file ( $AI{"DEFAULT_CONFIG"}, "smtpscan.license", ("LicenseDomains" => $licdomains) );
	}

	# Try to install all the keys from the list
	@errormsgs = ();
	my $installed = 0;
	foreach my $keyfile (keys %validkeys)
	{
		$keyfile =~ s/\/+/\//g; # remove extra /

		my ($rc, $msg) = klinstall::exec_cmd_safe ("$lictool", "-q", "-a", $keyfile);
		if ( $rc == 0 )
		{
			klinstall::output ("License file %1 has been installed", $keyfile);
			$installed = 1;
		}
		else
		{
			push @errormsgs, "Error copying license file $keyfile to $AI{PATH_LICENSES}: $msg";
		}
	}

	# Fix the permissions
	klinstall::exec_cmd_safe ("chown", "-R", "$KLUSER:$KLGROUP", $AI{"PATH_LICENSES"});
	return if $installed;

	klinstall::output ("\n" . join ("\n", @errormsgs)) if @errormsgs;
	return "None of the Kaspersky Lab license files found can be installed for this product.";
}


sub setup_http_proxy
{
	my $addr = shift;
	my %AI = get_application_info();
	klinstall::warning ("Could not set up proxy address: ", klinstall::get_ini_error())
		if !klinstall::update_ini_file ( $AI{"DEFAULT_CONFIG"}, "updater.options", ("ProxyAddress" => $addr, "UseProxy" => "yes") );
}


sub update_AV_database
{
	my %AI = get_application_info();
	my $updater_cmd = "$AI{PATH_KEEPUP2DATE} -k -c $AI{DEFAULT_CONFIG} -p $APPID";

	# Escape shell args
	klinstall::output "\nRunning keepup2date to update your anti-virus database.\n";
	$updater_cmd =~ s/([\&;\`'\\\|"*?~<>^\(\)\[\]\{\}\$\n\r])/\\$1/g;

	my $retcode = system ("$updater_cmd");
	
	# return code 1 is 256. perldoc -f wait
	return (defined $retcode && ($retcode == 0 || $retcode == 256)) ? 1 : 0;
}


sub kavms_get_using_mailserver()
{
	my %mailserver_data =
		(
			"sendmail"	=>
				{
				"binname" => "sendmail",
				"confname" => "sendmail.cf",
				"binpaths" => [ "/usr/sbin", "/usr/local/sbin", "/usr/sbin" ],
				"confpaths" => [ "/etc/mail", "/usr/local/etc/mail", "/etc" ]
				},

			"qmail"		=> 
				{
				"binname" => "qmail-queue",
				"binpaths" => [ "/var/qmail/bin" ],
				},
			
			"postfix"	=>
				{
				"binname" => "postfix",
				"confname" => "master.cf",
				"binpaths" => [ "/usr/sbin", "/usr/local/sbin" ],
				"confpaths" => [ "/etc/postfix", "/usr/local/etc/postfix" ],
				"dont_ask_bins" => 1
				},

			"exim"	=>
				{
				"binname" => "exim",
				"confname" => "exim.conf",
				"binpaths" => [ "/usr/sbin", "/usr/local/sbin" ],
				"confpaths" => [ "/etc/exim" ]
				},
		);

	my %msconfig;

	# Find the mail server the customer is using.
	# Sendmail should be searched AFTER postfix and exim; use 'sort' for this
	foreach my $mailer (sort keys %mailserver_data)
	{
		my %rec = %{$mailserver_data{$mailer}};
		my @bins = @{$rec{"binpaths"}};

		# Search for binary and config
		for (my $i = 0; $i < scalar(@bins); $i++)
		{
			next if ! -x "$bins[$i]/$rec{binname}";
			
			if ( $rec{"confpaths"} )
			{
				# There could be several binary paths and less config paths
				# In this case, first config path will be used.
				my @confs = @{$rec{"confpaths"}};
				my $ci = $i;
				$ci = 0 if $i >= scalar (@confs);
				next if ! -f "$confs[$ci]/$rec{confname}";
				$msconfig{"conf"} = "$confs[$ci]/$rec{confname}";
			}
			else
			{
				$msconfig{"conf"} = "not needed";
			}

			$msconfig{"found"} = 1;
			$msconfig{"type"} = $mailer;
			$msconfig{"bin"} = "$bins[$i]/$rec{binname}";
			last;
		}

		last if $msconfig{"found"};
	}

	# Confirm all the data
	return %msconfig 
		if $msconfig{"found"} 
		&& klinstall::ask_boolean ("KAVMS_SETUP_CONFIRM_FOUND", "Y", $SETUPMSG_1, $msconfig{"type"}, $msconfig{"bin"}, $msconfig{"conf"}) == 1;

	# If not found, we should confirm the mail server configuration at all
	if ( !$msconfig{"found"}
	&& klinstall::ask_boolean ("KAVMS_SETUP_AT_ALL", "Y", $SETUPMSG_2) != 1 )
	{
		my %APPINFO = appdata::get_application_info();
		klinstall::output ($SETUPMSG_3, $APPINFO{"COMP_SETUP_SCRIPT"});
        return;
	}

	# Autodetect failed or not confirmed. 
	# Ask the user for the mail server type.
	while ( 1 )
	{
		my $type = klinstall::ask_question ("KAVMS_SETUP_MAILSERVER_TYPE", "sendmail", $SETUPMSG_4);
		$type =~ s/\s//g;

		if ( !$mailserver_data{$type} )
		{
			klinstall::output ("Invalid server type: %1", $type);
			next;
		}

		$msconfig{"type"} = $type;
		last;
	}

	# Ask user for binaries (only if mailer does not specify 'dont_ask_bins')
	while ( !$mailserver_data{$msconfig{"type"}}->{"dont_ask_bins"} )
	{
		my @bins = @{$mailserver_data{$msconfig{"type"}}->{"binpaths"}};
		my $binpath = klinstall::ask_question ("KAVMS_SETUP_MAILSERVER_BINPATH", $bins[0] . "/" . $mailserver_data{$msconfig{"type"}}->{"binname"}, $SETUPMSG_5, $msconfig{"type"}, $mailserver_data{$msconfig{"type"}}->{"binname"});

		-d $binpath and $binpath .= "/$mailserver_data{$msconfig{type}}->{binname}";
		if ( !-f $binpath || !-x $binpath )
		{
			klinstall::output ("File not found, or not an executable: %1", $binpath);
			next;
		}

		$msconfig{"bin"} = $binpath;
		last;
	}

	# Ask user for configuration file (only if !qmail)
	while ( defined $mailserver_data{$msconfig{"type"}}->{"confpaths"} )
	{
		my @confs = @{$mailserver_data{$msconfig{"type"}}->{"confpaths"}};
		my $confpath = klinstall::ask_question ("KAVMS_SETUP_MAILSERVER_CONFPATH", $confs[0] . "/" . $mailserver_data{$msconfig{"type"}}->{"confname"}, $SETUPMSG_6, $msconfig{"type"}, $mailserver_data{$msconfig{"type"}}->{"confname"});

		-d $confpath and $confpath .= "/$mailserver_data{$msconfig{type}}->{confname}";
		if ( !-f $confpath )
		{
			klinstall::output ("File not found: %1", $confpath);
			next;
		}

		$msconfig{"conf"} = $confpath;
		last;
	}

	return %msconfig;
}


sub make_kas_backup
{
	my ($kasdir, $origfilename, $newext) = @_;

	die if $origfilename !~ /.*\/(.*)/;
	my $filename = $1;

	my $msg = klinstall::copy_file ($origfilename, "$kasdir/$filename.$newext");
	klinstall::warning ($msg) if $msg;
}


sub change_script
{
        my ($filename, %vars) = @_;

        open F, "<$filename" or return "Could not read file $filename: $!";
        my $data = join ("", <F>);
        close F;

        foreach my $name (keys %vars)
        {
                my $value = $vars{$name};
                $data =~ s/^$name=.*$/$name=\"$value\"/m;
        }

        open F, ">$filename" or return "Could not write file $filename: $!";
        print F $data;
        close F;
	return;
}


sub kavms_setup_sendmail
{
	my ($confpath, $binpath, $smtpscanpath, $airef, $kasdatadir) = @_;
	my @changedfiles;
	my $spool = "/var/spool/mqueue.kav";
	my $pidpath = "/var/run/sm-listen.pid";
	my $newcf = "$confpath.listen";
	my $runscript = "$airef->{INSTROOT}/contrib/run_sendmail.sh";
	my $initscript = "$airef->{INSTROOT}/init.d/kavsendmail.sh";

	if ( -f $newcf )
	{
		klinstall::warning ("$newcf already exist.\nKaspersky Anti-Virus installer will create a backup copy of this file as $newcf.backup.\n");
		klinstall::copy_file ($newcf, "$newcf.backup");
		make_kas_backup ($kasdatadir, $newcf, "orig");
	}

	my $msg = klinstall::make_path ($spool, 0755) if !-d $spool;
	klinstall::fatal ("Configuration aborted: %1", $msg) if $msg;

	# KAS stuff
	open F, "<$confpath" or klinstall::fatal ("Configuration aborted: could not read $confpath: $!");
	my $sendmailcf = join ("", <F>);
	close F;

	# If Kaspersky Anti-Spam is present, remove everything 
	# it has been added to the sendmail.cf
	if ( $sendmailcf =~ /^(O InputMailFilters.*?kasfilter.*?)$/m )
	{
		make_kas_backup ($kasdatadir, $confpath, "orig");
		push @changedfiles, $confpath;

		my $oldcf = $sendmailcf;
		$oldcf =~ s/^Xkasfilter.*$//gmi;

		# /O InputMailFilters/ cleanup - remove kasfilter
		$oldcf =~ s/(^O InputMailFilters=.*?),?\s*kasfilter(,?.*?)$/$1$2/mgi;

		# Remove empty /O InputMailFilters=\n/ strings
		$oldcf =~ s/^O InputMailFilters=\s+//msgi;

		# Remove the first comma from strings like /O InputMailFilters=,newfilter/
		$oldcf =~ s/^(O InputMailFilters=)\s*,/$1/mgi;

		open F, ">$confpath" or klinstall::fatal ("Configuration aborted: could not write $confpath: $!");
		print F $oldcf;
		close F;
	}

	$sendmailcf =~ s/^(O QueueDirectory).*$/$1=$spool/m;
	$sendmailcf =~ s/^(SParseLocal=98)/$1\n\nR\$*\t\t\$#smtpscanner \$\@\$1 \$:\$1/m;

	# replace the pid file
	$sendmailcf =~ s/^#?\s*(O PidFile).*$/$1=$pidpath/m;

	$sendmailcf .= <<EOMSG;

######################*****##########################
###   Kaspersky SmtpScanner Mailer specification  ###
##################*****##############################

Msmtpscanner,	P=$smtpscanpath, F=PSXmnz9, S=EnvFromSMTP/HdrFromSMTP, R=EnvToSMTP, E=\\r\\n, L=2040,
\t\tT=SMTP,
\t\tU=$KLUSER,
\t\tA=smtpscanner
EOMSG

	open F, ">$newcf" or klinstall::fatal ("Configuration aborted: could not create new sendmail configuration file $newcf: $!");
	print F $sendmailcf;
	close F;

	open F, ">$runscript" or klinstall::fatal ("Configuration aborted: could not create sendmail startup script $runscript: $!");
	print F <<EOMSG;
#!/bin/sh

$initscript start
EOMSG
	close F;
	chmod 0755, $runscript;
	
	$msg = change_script ($initscript, "sendmail_bin" => $binpath, "sendmail_cf" => $confpath, "sendmail_listen_cf" => $newcf);
	klinstall:fatal ($msg) if $msg;

	klinstall::warning ($SETUPMSG_7, klinstall::get_ini_error())
		if !klinstall::update_ini_file ($airef->{"DEFAULT_CONFIG"}, "smtpscan.general", ("ForwardMailer" => "smtp:($binpath -bs -C $confpath)") );

	klinstall::output ($SETUPMSG_8, "sendmail", $runscript);

	make_kas_backup ($kasdatadir, $confpath, "modified");
	make_kas_backup ($kasdatadir, $newcf, "modified");

	push @changedfiles, $newcf;
	return @changedfiles;
}


sub kavms_setup_exim
{
	my ($confpath, $binpath, $smtpscanpath, $airef, $kasdatadir) = @_;
	my @changedfiles;
	my $newcf = "$confpath.listen";
	my $kascfg = "/usr/local/ap-mailfilter/etc/kas-pipe-exim.conf";
	my $runscript = "$airef->{INSTROOT}/contrib/run_exim.sh";
	my $initscript = "$airef->{INSTROOT}/init.d/kavexim.sh";
	my $kav_lmtp_transport = "kav_lmtp_transport :\n  driver = lmtp\n  user = $KLUSER\n  command = $smtpscanpath";

	open F, "<$confpath" or klinstall::fatal ("Configuration aborted: could not read $confpath: $!");
	my @eximcf = <F>;
	close F;

	# Check whether the KAS is set up
	if ( -f $newcf && -f $kascfg )
	{
		# KAS is set up. Integrate into $kascfg
		open F, "<$kascfg" or klinstall::fatal ("Configuration aborted: could not read $kascfg: $!");
		my $data = join ("", <F>);
		close F;

		make_kas_backup ($kasdatadir, $kascfg, "orig");

		$data =~ s/\r//g;
		$data =~ s/^OutProtocolLMTP .*/OutProtocolLMTP yes/m;

		$data =~ /^OutgoingAddr\s+exec:(.*)/m or klinstall::fatal ("Configuration aborted: strange (non-exec) exim integration; probably newest version of KAS?");
		klinstall::warning ($SETUPMSG_7, klinstall::get_ini_error())
			if !klinstall::update_ini_file ($airef->{"DEFAULT_CONFIG"}, "smtpscan.general", ("ForwardMailer" => "smtp:($1)") );

		$data =~ s/^OutgoingAddr .*/OutgoingAddr exec:$smtpscanpath/m;

		open F, ">$kascfg" or klinstall::fatal ("Configuration aborted: could not write $kascfg: $!");
		print F $data;
		close F;

		make_kas_backup ($kasdatadir, $kascfg, "modified");
		push @changedfiles, $kascfg;
		return @changedfiles;
	}
	
	# Get the exim version
	klinstall::output ("Getting the exim mailer version by executing exim.");
	my $eximoutput = `$binpath -bV 2>/dev/null`;
	if ( $eximoutput =~ /Exim\s+version\s+([\d\.]+)/ && $1 < 4.0 )
	{
		$kav_lmtp_transport .= "\n  home_directory = /var/db/kav";
	}
	
	# If exim.listen is present, and it is not KAS file, make a backup.
	if ( -f $newcf )
	{
		klinstall::warning ("$newcf already exist.\nKaspersky Anti-Virus installed made a copy of this file as $newcf.backup.\n");
		klinstall::copy_file ($newcf, "$newcf.backup");
		make_kas_backup ($kasdatadir, $newcf, "orig");
	}

	# KAS stuff - backup an original config
	make_kas_backup ($kasdatadir, $confpath, "orig");
	push @changedfiles, $confpath;

	my $confdata = join ("", @eximcf);
	if ( $confdata =~ /^\s*trusted_users\s*=(.*)/m )
	{
		my $exusers = $1;

		if ( $exusers !~ /\b$KLUSER\b/ )
		{
			my $adduser = ($exusers =~ /^\s*$/) ? $KLUSER : " : $KLUSER";
			$confdata =~ s/^(\s*trusted_users = .*)\n/$1$adduser\n/m;
			open F, ">$confpath" or klinstall::fatal ("Configuration aborted: could not modify exim configuration file $confpath: $!");
			print F $confdata;
			close F;
		}
	}
	else
	{
		$confdata =~ s/^(\s*begin\s.*)$/trusted_users = $KLUSER\n$1/m;
		open F, ">$confpath" or klinstall::fatal ("Configuration aborted: could not modify exim configuration file $confpath: $!");
		print F $confdata;
		close F;
	}

	open F, ">$newcf" or klinstall::fatal ("Configuration aborted: could not create new exim configuration file $newcf: $!");
	my $found = 0;
	my $transport_added = 0;

	foreach (@eximcf)
	{
		if ( /^(localuser|dnslookup|local_user|real_local):$/ )
		{
			$found = 1 ;
			print F $_;
			next;
		}

		$found = 0 if $found && s/(.*)transport.*/$1transport = kav_lmtp_transport/;
		
		if ( /^local_delivery:/ && !$transport_added )
		{
		    $transport_added = 1;
                    print F "$kav_lmtp_transport\n\n";
		}

		print F $_;
		
		if ( /^begin\stransports/ )
		{
		    $transport_added = 1;
		    print F "\n$kav_lmtp_transport\n";
		}
	}
	close F;

	open F, ">$runscript" or klinstall::fatal ("Configuration aborted: could not create exim startup script $runscript: $!");
	print F <<EOMSG;
#!/bin/sh

$initscript start
EOMSG
	close F;
	chmod 0755, $runscript;

	$msg = change_script ($initscript, "exim_bin" => $binpath, "exim_conf" => $confpath, "exim_listen_conf" => $newcf);
	klinstall:fatal ($msg) if $msg;

	klinstall::warning ($SETUPMSG_7, klinstall::get_ini_error())
		if !klinstall::update_ini_file ($airef->{"DEFAULT_CONFIG"}, "smtpscan.general", ("ForwardMailer" => "smtp:($binpath -bs -C $confpath)") );

	klinstall::output ($SETUPMSG_8, "exim", $runscript);
	return @changedfiles;
}


# To ignore absense of IO::Socket::INET, this sub call should be wrapped
# into the eval block
sub safely_check_local_port
{
	my $port = shift;
	require IO::Socket::INET;
	my $sock = IO::Socket::INET->new (PeerAddr => '127.0.0.1',
                                 	PeerPort => $port,
                                 	Proto    => 'tcp');
	die if !$sock;
	return 1;
}


sub kavms_setup_postfix
{
	my ($confpath, $smtpscanpath, $airef, $kasdatadir) = @_;
	my @changedfiles;
	my $backuppath = "$confpath.backup";
	my $kascfg = "/usr/local/ap-mailfilter/etc/kas-pipe-postfix.conf";

	my $home = "/var/spool/filter";
	klinstall::exec_zero ("mkdir -p $home") if ! -d $home;
	klinstall::lazy_chown ("$KLUSER:$KLGROUP", $home);

	# Read master.cf
	open F, "<$confpath" or klinstall::fatal ("Configuration aborted: could not read $confpath: $!");
	my $postfixcf = join ("", <F>);
	close F;

	# Create a backup copy
	open F, ">$backuppath" or klinstall::fatal ("Configuration aborted: could not write $backuppath: $!");
	print F $postfixcf;
	close F;

	if ( $postfixcf =~ /### KASPERSKY ANTI-SPAM  BEGIN ###/ )
	{
		# KAS is set up. Integrate into $kascfg
		open F, "<$kascfg" or klinstall::fatal ("Configuration aborted: could not read $kascfg: $!");
		my $data = join ("", <F>);
		close F;

		make_kas_backup ($kasdatadir, $kascfg, "orig");
		push @changedfiles, $kascfg;

		if ( $data =~ /^OutgoingAddr\s+tcp:.*?:(\d+)/im )
		{
			klinstall::warning ($SETUPMSG_7, klinstall::get_ini_error())
				if !klinstall::update_ini_file ($airef->{"DEFAULT_CONFIG"}, "smtpscan.general", ("ForwardMailer" => "smtp:127.0.0.1:$1") );
		}

		$data =~ s/\r//g;
		$data =~ s/^OutProtocolLMTP .*/OutProtocolLMTP yes/m;
		$data =~ s/^OutgoingAddr .*/OutgoingAddr exec:$smtpscanpath/m;

		open F, ">$kascfg" or klinstall::fatal ("Configuration aborted: could not write $kascfg: $!");
		print F $data;
		close F;

		make_kas_backup ($kasdatadir, $kascfg, "modified");
		return @changedfiles;
	}

	# Remove everything if already set up in config
	$postfixcf =~ s/##<KIS55> ## Added by Kaspersky Anti-Virus Installer ##.*?##<KIS55> ## Added by Kaspersky Anti-Virus Installer ##\n//gs;

	# Check for registration from version 5.0
	if ( $postfixcf =~ /^## This line is added by Kaspersky Antivirus Installer.+?^##$/ms
	|| $postfixcf =~ /^## Added by Kaspersky Anti-Virus Installer ##.+?^## Added by Kaspersky Anti-Virus Installer ##/ms )
	{
		$postfixcf =~ s/^## This line is added by Kaspersky Antivirus Installer.+?^##$//msg;
        $postfixcf =~ s/^## Added by Kaspersky Anti-Virus Installer ##.+?^## Added by Kaspersky Anti-Virus Installer ##//msg;

		# also clean up main.cf
		my $maincf = $confpath;
		$maincf =~ s/master\.cf$/main.cf/;
		if ( open F, "<$maincf" )
		{
			my $maincfdata = join ("", <F>);
			close F;

			$maincfdata =~ s/^## This line is added by Kaspersky Antivirus Installer.+?^##$//msg;
            $maincfdata =~ s/^## Added by Kaspersky Anti-Virus Installer ##.+?^## Added by Kaspersky Anti-Virus Installer ##//msg;

            if ( open F, ">$maincf" )
            {
            	print F $maincfdata;
            	close F;
            	$maincf = undef;
            }
		}

		klinstall::warning ("Could not clean up Postfix main.cf configuration file. Please do this manually")
			if $maincf;
	}

	# Look up for two free ports
	klinstall::output ("\nProbing for two free ports - please wait.\n");
	my @ports;
	foreach (10030 ... 49152)
	{
		next if $postfixcf =~ /:$_/;
		next if eval { safely_check_local_port($_); };

		klinstall::output ("Checking port: $_ - Ok\n");
		push @ports, $_;
		last if scalar (@ports) > 1;
	}

	my $extrasection = "#<KIS55>\n"
			. "127.0.0.1:$ports[0]     inet  n      n      n      -      20     spawn\n"
			. "\t\tuser=$KLUSER   argv=$smtpscanpath\n"
			. "127.0.0.1:$ports[1]    inet  n      -      n      -      21      smtpd\n"
			. "\t -o content_filter=\n"
			. "\t -o local_recipient_maps=\n"
			. "\t -o relay_recipient_maps=\n"
			. "\t -o smtpd_restriction_classes=\n"
			. "\t -o smtpd_client_restrictions=\n"
			. "\t -o smtpd_helo_restrictions=\n"
			. "\t -o smtpd_sender_restrictions=\n"
			. "\t -o mynetworks=127.0.0.0/8\n"
			. "\t -o strict_rfc821_envelopes=yes\n"
			. "\t -o smtpd_error_sleep_time=0\n"
			. "\t -o smtpd_soft_error_limit=1001\n"
			. "\t -o smtpd_hard_error_limit=1000\n"
			. "\t -o myhostname=" . `hostname` . "\n"
			. "#<KIS55>\n";

	my $contentfilter = "##<KIS55> ## Added by Kaspersky Anti-Virus Installer ## \n"
			. "\t\t-o content_filter=lmtp:127.0.0.1:$ports[0]\n"
			. "## Added by Kaspersky Anti-Virus Installer ##<KIS55>\n";

	$postfixcf =~ s/(^smtp\s+inet\s+.*smtpd\s*\n)/$1$contentfilter/mg;
	$postfixcf =~ s/(^pickup\s+fifo\s+.*pickup\s*\n)/$1$contentfilter/mg;

	$postfixcf .= $extrasection;

	make_kas_backup ($kasdatadir, $confpath, "orig");
	push @changedfiles, $confpath;

	# Overwrite master.cf
	open F, ">$confpath" or klinstall::fatal ("Configuration aborted: could not modify Postfix configuration file $confpath: $!");
	print F $postfixcf;
	close F;

	klinstall::warning ($SETUPMSG_7, klinstall::get_ini_error())
		if !klinstall::update_ini_file ($airef->{"DEFAULT_CONFIG"}, "smtpscan.general", ("ForwardMailer" => "smtp:127.0.0.1:$ports[1]") );

	klinstall::output ($SETUPMSG_9);
	return @changedfiles;
}



sub kavms_setup_qmail
{
	my ($binpath, $smtpscanpath, $airef, $kasdatadir) = @_;
	my @changedfiles;
	my ($newbinpath, $origbinary, $kasbinary) = ($binpath, $binpath, $binpath);
	$newbinpath =~ s/qmail-queue/qmail-queue.kav55/;
	$kasbinary =~ s/qmail-queue/qmail-queue.kas/;
	$origbinary =~ s/qmail-queue/qmail-que/;

	# Restore original qmail-queue if needed
	if ( -f $origbinary )
	{
		klinstall::install_file ($origbinary, $binpath, '4711', "qmailq:qmail");
		unlink ($origbinary);
	}

	if ( -f $kasbinary )
	{
		# KAS-specific logic.
		make_kas_backup ($kasdatadir, $kasbinary, "orig");

		# This is original qmail-queue
		rename $kasbinary, $newbinpath if ! -f $newbinpath;
		klinstall::install_file ($airef->{"PATH_QMAILQUE"}, $kasbinary, '4711', "kluser:qmail");

		make_kas_backup ($kasdatadir, $kasbinary, "modified");
		make_kas_backup ($kasdatadir, $newbinpath, "modified");

		push @changedfiles, $kasbinary;
		push @changedfiles, $newbinpath;
	}
	else
	{
		# And install new
		if ( ! -f $newbinpath )
		{
			klinstall::install_file ($binpath, $newbinpath, '4711', "qmailq:qmail");
			my %appdata = klinstall::read_app_info ($APPID);
			push @{$appdata{"FILE"}}, $newbinpath;
			klinstall::write_app_info ($APPID, %appdata);
		}

		make_kas_backup ($kasdatadir, $binpath, "orig");
		klinstall::install_file ($airef->{"PATH_QMAILQUE"}, $binpath, '4711', "kluser:qmail");

		make_kas_backup ($kasdatadir, $binpath, "modified");
		push @changedfiles, $binpath;
	}

	klinstall::warning ($SETUPMSG_7, klinstall::get_ini_error())
		if !klinstall::update_ini_file ($airef->{"DEFAULT_CONFIG"}, "smtpscan.general", ("ForwardMailer" => "qmail:($newbinpath)") );
		
	klinstall::output ($SETUPMSG_10);

	# For Qmail, we need to convert all administrators from /var/qmail/alias/.qmail-postmaster
	# to workaround the message loop.	
	my @adminrecipients = ("postmaster\@localhost");

	if ( open F, "</var/qmail/alias/.qmail-postmaster" )
	{
		while ( <F> )
		{
			s/[\n\r]//g;
			m/^\&(.*)/ and push @adminrecipients, quotemeta ($1)
				or m/^[\d\w]/ and push @adminrecipients, quotemeta ($_)
		}

		close F;
	}

	my $reclist = join (",", @adminrecipients);
	klinstall::update_ini_file ($airef->{"DEFAULT_CONFIG"}, "smtpscan.group:kavadministrators", ("Recipients" => $reclist) );

	return @changedfiles;
}


sub _replace_ini_value
{
	my ($c1, $c2, $sec, $key) = @_;
	my $value = klinstall::get_ini_value ($c2, $sec, $key);
	return if !defined $value;
	klinstall::set_ini_value ($c1, $sec, $key, $value);
}


sub kav_import_settings_5030
{
	my ($c5030, $c55) = @_;

	# Store old values
	my $oldbasespath = klinstall::get_ini_value ($c5030, "path", "BasesPath");
	my $oldkeysspath = klinstall::get_ini_value ($c5030, "path", "LicensePath");
	my $oldbackuppath = klinstall::get_ini_value ($c5030, "path", "BackupPath");
	my $newbasespath = klinstall::get_ini_value ($c55, "path", "BasesPath");
	my $newkeysspath = klinstall::get_ini_value ($c55, "path", "LicensePath");
	my $newbackuppath = klinstall::get_ini_value ($c55, "updater.path", "BackUpPath");

	# Replace the values
	_replace_ini_value ($c5030, $c55, "path", "BasesPath");
	_replace_ini_value ($c5030, $c55, "path", "LicensePath");
	_replace_ini_value ($c5030, $c55, "path", "LocalSocketPath");
	_replace_ini_value ($c5030, $c55, "path", "IcheckerDbFile");
	_replace_ini_value ($c5030, $c55, "updater.options", "PostUpdateCmd");
	_replace_ini_value ($c5030, $c55, "updater.report", "ReportFileName");
	_replace_ini_value ($c5030, $c55, "scanner.report", "ReportFileName");
	_replace_ini_value ($c5030, $c55, "aveserver.report", "ReportFileName");

	klinstall::set_ini_value ($c5030, "updater.path", "BackUpPath", $newbackuppath);
	klinstall::set_ini_value ($c5030, "updater.path", "AVBasesTestPath", klinstall::get_ini_value ($c55, "updater.path", "AVBasesTestPath"));
	klinstall::set_ini_value ($c5030, "updater.path", "DiffUtilPath", klinstall::get_ini_value ($c55, "updater.path", "DiffUtilPath"));
	klinstall::set_ini_value ($c5030, "updater.path", "UploadPatchPath", klinstall::get_ini_value ($c55, "updater.path", "UploadPatchPath"));

	my $passftp = klinstall::get_ini_value ($c55, "updater.options", "PassiveFtp");
	$passftp = "no" if !$passftp;
	klinstall::set_ini_value ($c5030, "updater.options", "PassiveFtp", $passftp);
	klinstall::set_ini_value ($c5030, "updater.options", "UpdateServerUrl", "");

	klinstall::remove_ini_value ($c5030, "path", "BackUpPath");
	klinstall::remove_ini_value ($c5030, "path", "UserFile");

	klinstall::set_ini_value ($c5030, "scanner.options", "UseAVbasesSet", "standard");
	klinstall::set_ini_value ($c5030, "aveserver.options", "UseAVbasesSet", "standard");

	klinstall::set_ini_value ($c5030, "updater.options", "RegionSettings", "Russia")
		if !klinstall::get_ini_value ($c5030, "updater.options", "RegionSettings");

	klinstall::set_ini_value ($c5030, "updater.options", "ConnectTimeout", "30")
		if !klinstall::get_ini_value ($c5030, "updater.options", "ConnectTimeout");

	klinstall::set_ini_value ($c5030, "smtpscan.report", "ReportLevel", klinstall::get_ini_value ($c5030, "smtpscan.report", "ReportLevel") + 1)
		if klinstall::get_ini_value ($c5030, "smtpscan.report", "ReportLevel");

	klinstall::set_ini_value ($c5030, "aveserver.report", "ReportLevel", klinstall::get_ini_value ($c5030, "aveserver.report", "ReportLevel") + 1)
		if klinstall::get_ini_value ($c5030, "aveserver.report", "ReportLevel");

	klinstall::set_ini_value ($c5030, "scanner.report", "ReportLevel", klinstall::get_ini_value ($c5030, "scanner.report", "ReportLevel") + 1)
		if klinstall::get_ini_value ($c5030, "scanner.report", "ReportLevel");

	klinstall::set_ini_value ($c5030, "updater.report", "ReportLevel", klinstall::get_ini_value ($c5030, "updater.report", "ReportLevel") + 1)
		if klinstall::get_ini_value ($c5030, "updater.report", "ReportLevel");

	# For mail servers
	if ( $MODE_MAILSERVER )
	{
		_replace_ini_value ($c5030, $c55, "smtpscan.report", "ReportFileName");
		klinstall::remove_ini_value ($c5030, "smtpscan.license", "LicenseWarningNotifySize");
		klinstall::set_ini_value ($c5030, "smtpscan.general", "Protocol", "lmtp");

		# Replace all the Template= entries in [smtpscan.notify*]
		foreach my $name (keys %{$c5030->{"sections"}})
		{
			next if $name !~ /^smtpscan\.notify/;
			$c5030->{"sections"}->{$name} =~ s/^(template=\/etc\/kav)\/5.0\/(.*)$/$1\/5.5\/kav4mailservers\/templates\/$2/mgi;
		}

		# Copy the templates
		klinstall::output ("Copying old templates to /etc/kav/5.5/kav4mailservers/templates/\n");
		klinstall::copy_files ("/etc/kav/5.0/", "/etc/kav/5.5/kav4mailservers/templates/", "^template");
	}

	klinstall::output ("Copying license files\n");
	klinstall::copy_files ($oldkeysspath, $newkeysspath, "\.key\$|\.dat\$");

	klinstall::output ("Copying anti-virus bases\n");
	klinstall::copy_files ($oldbasespath, $newbasespath, ".+");

	if ( $oldbackuppath && -d $oldbackuppath )
	{
		klinstall::output ("Copying anti-virus bases backup\n");
		klinstall::copy_files ($oldbackuppath, $newbackuppath, ".+");
	}
}


sub kav_import_settings_5000
{
	my ($c50, $c55) = @_;

	# store the values
	my $extrawget = klinstall::get_ini_value ($c50, "updater.options", "ExtraWgetOptions");
	my $keepsil = klinstall::get_ini_value ($c50, "updater.options", "KeepSilent");

	# Wipe the section, and add new values
	klinstall::remove_ini_value ($c50, "path", "UpdateServersFile");
	klinstall::remove_ini_value ($c50, "updater.options");
	klinstall::set_ini_value ($c50, "updater.options", "KeepSilent", $keepsil);
	klinstall::set_ini_value ($c50, "updater.options", "ProxyAddress", "");
	klinstall::set_ini_value ($c50, "updater.options", "UseProxy", "no");
	klinstall::set_ini_value ($c50, "updater.options", "UseUpdateServerUrl", "no");
	klinstall::set_ini_value ($c50, "updater.options", "UseUpdateServerUrlOnly", "no");
	klinstall::set_ini_value ($c50, "updater.options", "UpdateServerUrl", "");
	klinstall::set_ini_value ($c50, "updater.options", "RegionSettings", "");
	klinstall::set_ini_value ($c50, "updater.options", "ConnectTimeout", "");
	klinstall::set_ini_value ($c50, "updater.options", "PassiveFtp", "no");

	klinstall::set_ini_value ($c50, "scanner.options", "Ichecker", "yes");
	klinstall::set_ini_value ($c50, "scanner.path", "BackupPath", "");

	klinstall::output ($IMPORTMSG_3, $extrawget) if $extrawget;

	kav_import_settings_5030 ($c50, $c55);
}


sub kav_import_settings_4000
{
	my ($cfg40, $c55) = @_;
	my %AI = appdata::get_application_info();

	my $mode = $MODE_MAILSERVER ? "ms" : "fs";
	klinstall::exec_zero ("perl $AI{PATH_CONV40SCRIPT} $mode $AI{DEFAULT_CONFIG}");

	# remove 4.0 startup scripts
	unlink ("/etc/init.d/kavwt");
	unlink ("/etc/init.d/kavcc");
}


sub kav_import_settings
{
	my $cfg50 = $MODE_MAILSERVER ? "/etc/kav/5.0/kav4mailservers.conf" : "/etc/kav/5.0/kav4unix.conf";
	my $cfg40 = -f "/opt/AVP/AvpUnix.ini" ? "/opt/AVP/AvpUnix.ini" : "/usr/local/share/AVP/AvpUnix.ini";

	return if !-f $cfg50 && !-f $cfg40;

	my %AI = appdata::get_application_info();
	my $confbackup = "$AI{DEFAULT_CONFIG}.original";

	my %newconf = klinstall::load_ini_file ($AI{"DEFAULT_CONFIG"});
	klinstall::save_ini_file ($confbackup, %newconf);

	if ( -f $cfg50 )
	{
		my %oldconf = klinstall::load_ini_file ($cfg50);
		return if !%oldconf || !$oldconf{"sections"};

		if ( $oldconf{"sections"}->{"updater.options"} =~ /^PostUpdateCmd=/m )
		{
			return if klinstall::ask_boolean ("KAVMS_IMPORT_START_5030", "Y", $IMPORTMSG_1, "version 5.0.3 and above", $cfg50) == 0;
			kav_import_settings_5030 (\%oldconf, \%newconf);
			klinstall::output ($IMPORTMSG_2, $AI{"DEFAULT_CONFIG"}, $confbackup);
		}
		else
		{
			return if klinstall::ask_boolean ("KAVMS_IMPORT_START_5000", "Y", $IMPORTMSG_1, "version 5.0", $cfg50) == 0;
			kav_import_settings_5000 (\%oldconf, \%newconf);
			klinstall::output ($IMPORTMSG_4, $AI{"DEFAULT_CONFIG"}, $confbackup);
		}

		klinstall::save_ini_file ($AI{"DEFAULT_CONFIG"}, %oldconf)
			or print "Could not save new configuration file: " . klinstall::get_ini_error();
	}
	else
	{
		return if klinstall::ask_boolean ("KAVMS_IMPORT_START_4000", "Y", $IMPORTMSG_1, "version 4.0", $cfg40) == 0;
		kav_import_settings_4000 ($cfg40, \%newconf);
		klinstall::output ($IMPORTMSG_5, "$AI{DEFAULT_CONFIG}.new", $AI{"DEFAULT_CONFIG"});
	}
}


sub detect_kavkas_dir
{
	my $ms = shift;
	my $path = $KAVKASROOT;

	$ms eq "sendmail" and $path .= "/s"
		or $ms eq "qmail" and $path .= "/q"
			or $ms eq "postfix" and $path .= "/p"
				or $ms eq "exim" and $path .= "/e"
					or klinstall::fatal ("Unknown mailer: $ms");

	return "$path/1" if !-d "$path/1/" || !open F, "<$path/1/setup";
	my @res = grep (/^PRODUCT=KAV\s+$/s, <F>);
	close F;

	return "$path/1" if length(@res);
	return "$path/2";
}



sub kavms_setup
{
	print "\n\n";
	my %APPINFO = appdata::get_application_info();
	my ($rc, $outmsg) = klinstall::exec_cmd ("$APPINFO{INSTROOT}/bin/aveserver");

	# Ask again if the field is empty
	my %conf = klinstall::load_ini_file ($APPINFO{"DEFAULT_CONFIG"});

	if ( !klinstall::get_ini_value (\%conf, "smtpscan.license", "LicenseDomains") )
	{
		my $licdomains = klinstall::ask_question ("KAVMS_SETUP_LICENSE_DOMAINS", "*", $LICENSEMSG_3);

		klinstall::warning ("Could not set up license domains to $licdomains: ", klinstall::get_ini_error())
			if !klinstall::update_ini_file ( $APPINFO{"DEFAULT_CONFIG"}, "smtpscan.license", ("LicenseDomains" => $licdomains) );
	}

	if ( $rc != 0 && $rc != (33 << 8) )
	{
		return 1 if klinstall::ask_boolean ("KAVMS_SETUP_NOAVESERVER", "N", $SETUPMSG_11) == 0;
	}

	my %mssetup = kavms_get_using_mailserver();
	return if !%mssetup;

	my ($configpfn, @configargs);

	if ( $mssetup{"type"} eq "postfix" )
	{
		$configpfn = "kavms_setup_postfix";
		push @configargs, $mssetup{"conf"};
	}
	elsif ( $mssetup{"type"} eq "sendmail" )
	{
		$configpfn = "kavms_setup_sendmail";
		push @configargs, $mssetup{"conf"};
		push @configargs, $mssetup{"bin"};
	}
	elsif ( $mssetup{"type"} eq "exim" )
	{
		$configpfn = "kavms_setup_exim";
		push @configargs, $mssetup{"conf"};
		push @configargs, $mssetup{"bin"};
	}
	elsif ( $mssetup{"type"} eq "qmail" )
	{
		$configpfn = "kavms_setup_qmail";
		push @configargs, $mssetup{"bin"};
	}

	# Do previous backup
	my $kasdir = detect_kavkas_dir ($mssetup{"type"});
	klinstall::make_path ($kasdir, 0700) if !-d $kasdir;

	open SF, ">$kasdir/setup" or klinstall::fatal ("Could not write $kasdir/setup: $!");

	print SF "PRODUCT=KAV\n";
	print SF "VERSION=5.5\n";
	print SF "RECONFIGURE=perl $APPINFO{INSTROOT}/setup/reconfigure.pl " . join (" ", @configargs) . "\n";

	push @configargs, $APPINFO{"PATH_SMTPSCAN"};
	push @configargs, \%APPINFO;
	push @configargs, $kasdir;

	my @files = &$configpfn (@configargs);

	foreach (@files)
	{
		print SF "FILE=$_\n";
	}

	close SF;
	return 1;
}


sub kavfs_setup
{
	my %APPINFO = appdata::get_application_info();
	my $buildscript = "$APPINFO{INSTROOT}/src/build.pl";

	system ("perl $buildscript") if -f $buildscript;
	return 1;
}


sub app_modify_config_file
{
	kav_import_settings();
}


sub check_directory_permissions
{
	my %dirs = ( 
		"/var/log/kav/" => "0755 root",
		"/var/log/kav/5.5" => "0755 root",
		"/var/log/kav/5.5/kav4unix" => "0770 $KLUSER:$KLGROUP",
		"/var/log/kav/5.5/kav4mailservers" => "0770 $KLUSER:$KLGROUP",
		"/var/db/kav/5.5/kav4mailservers/licenses" => "0770 $KLUSER:$KLGROUP",
		"/var/db/kav/5.5/kav4unix/licenses" => "0770 $KLUSER:$KLGROUP",
		"/var/db/kav/5.5/kav4mailservers/licenses/application.dat" => "0666 $KLUSER:$KLGROUP",
		"/var/db/kav/5.5/kav4unix/licenses/application.dat" => "0666 $KLUSER:$KLGROUP"
		 );

	my %dirs2change;

	foreach my $dir ( keys %dirs )
	{
		die "Bad pattern: $dirs{$dir}" if $dirs{$dir} !~ /^(\d+) (\w+):?(\w+)?$/;
		my ($rmode, $ruser, $rgroup) = ($1, $2, $3);

		my @stats = stat ($dir) or next;
		my $dmode = $stats[2] & 07777;
		my $duser = getpwuid ($stats[4]);
		my $dgroup = getgrgid ($stats[5]);

		$dirs2change{$dir}->{"chmod"} = $rmode if oct($rmode) != $dmode;

		if ( $rgroup )	{
			$dirs2change{$dir}->{"chown"} = "$ruser:$rgroup" if $duser ne $ruser || $dgroup ne $rgroup;
		} else {
			$dirs2change{$dir}->{"chown"} = "$ruser" if $duser ne $ruser;
		}
	}

	return if !%dirs2change;

	while ( (my $answ = klinstall::ask_question ("KAV_SECURITY_FIX_PERMS", "Y", $SECURITY_CHECK_MSG_1, join (", ", @unsecuredirs))) !~ /^y/i )
	{
		return if $answ =~ /^n/i;

		if ( $answ eq '?' )
		{
			foreach my $d ( keys %dirs2change )
			{
				my @data;
				my $info = "Dir $d:";
				push @data, "chmod $dirs2change{$d}->{chmod}" if $dirs2change{$d}->{"chmod"};
				push @data, "chown $dirs2change{$d}->{chown}" if $dirs2change{$d}->{"chown"};

				print "$info " . join (", ", @data) . "\n";
			}
		}
	}

	foreach my $d ( keys %dirs2change )
	{
		chmod oct($dirs2change{$d}->{"chmod"}), $d or klinstall::warning ("Could not change permissions for $d")
			if $dirs2change{$d}->{"chmod"};

		klinstall::lazy_chown ($dirs2change{$d}->{"chown"}, $d) or klinstall::warning ("Could not change ownership for $d")
			if $dirs2change{$d}->{"chown"};
	}
}


sub app_register()
{
	klinstall::check_for_root ("setup script");
	check_directory_permissions();
	return $MODE_MAILSERVER ? kavms_setup() : kavfs_setup();
}


sub mailer_reconfigure
{
	my $mailer = shift;
	my $data = shift;

	my %APPINFO = appdata::get_application_info();
	my %appdata = klinstall::read_app_info ($APPID);

	my $funcname = "kavms_setup_$mailer";

	&$funcname ($data, $APPINFO{"PATH_SMTPSCAN"}, \%APPINFO, \%appdata);
}


sub compare_files
{
	my ($file1, $file2) = @_;

	open F, "<$file1" or return 1;
	my $c1 = join ("", <F>);
	close F;

	open F, "<$file2" or return 1;
	my $c2 = join ("", <F>);
	close F;
	return $c1 eq $c2;
}


sub check_and_restore_files
{
	my ($productname, $pathcheck, $pathrestore, @files) = @_;
	my $restoredfiles = 0;

	foreach my $file (@files)
	{
		die if $file !~ /(.*)\/(.*)/;
		my ($dir, $filename) = ($1, $2);
		my $origfile = "$pathrestore/$filename.orig";
		my $modfile = "$pathcheck/$filename.modified";
		my $olddate = -f $origfile ? scalar localtime ((stat($origfile))[9]) : "";

		# We can't do anything if modified file is absent
		if ( !-f $modfile )
		{
			klinstall::warning ("Installation backup file %1 has been removed. Unable to restore the old file.", $modfile);
			next;
		}

		# Compare modified and current configuration, and generate a warning
		# if they're different
		if ( -f $file && !compare_files ($file, $modfile) )
		{
			# the warning message differs depending of the file
			my $renamedfile = "$dir/$filename.modified";
			my $olddate = (-f $origfile) ? (scalar localtime ((stat($origfile))[9])) : undef;

			if ( !rename ($file, $renamedfile) )
			{
				klinstall::warning ("Could not rename file %1 to %2: %3. Unable to restore the old configuration.", $file, $renamedfile, $!);
				next;
			}

			if ( $olddate ) {
				klinstall::warning ($UNINSTALL_MSG_2, $file, $productname, $renamedfile, $olddate);
			} else { 
				klinstall::warning ($UNINSTALL_MSG_3, $file, $productname, $renamedfile);
			}
		}

		# Remove the newly created configuration file if exist
		if ( -f $file && !unlink ($file) )
		{
			klinstall::warning ("Could not remove file %1: %3. Unable to restore the old configuration.", $file, $!);
			next;
		}

		# And copy the original configuration file if exist
		if ( -f $origfile )
		{
			my $msg = klinstall::copy_file ($origfile, $file);
			if ( $msg )
			{
				klinstall::warning ($msg);
				next;
			}
		}

		$restoredfiles++;
	}

	return scalar (@files) == $restoredfiles;
}


sub app_unregister
{
	my %AI = appdata::get_application_info();
	my %appdata = klinstall::read_app_info ($APPID);

	# Remove mailer start scripts
	unlink ("$AI{INSTROOT}/contrib/run_sendmail.sh");
	unlink ("$AI{INSTROOT}/contrib/run_exim.sh");

	# Enumerate through all the directories in 1/ directory.
	my %installedproducts;
	foreach my $mailer ("s", "e", "p", "q")
	{
		foreach my $dir ("2", "1")
		{
			next if !-d "$KAVKASROOT/$mailer/$dir/" 
			|| !open F, "<$KAVKASROOT/$mailer/$dir/setup";

			my %productinfo;

			while ( <F> )
			{
				s/[\n\r]//g; # strip spaces
				next unless /([A-Z]+)=(.*)/;

				$1 eq "FILE" and push @{$productinfo{"FILE"}}, $2
					or $productinfo{$1} = $2;
			}

            close F;
            next if !defined ($productinfo{"PRODUCT"}) 
            	 || $productinfo{"PRODUCT"} !~ /^KAV$|^KAS$/;

            $installedproducts{$mailer}{$dir} = \%productinfo;
		}
	}

	foreach my $mailer ("s", "e", "p", "q")
	{
		next if !$installedproducts{$mailer};
		my $proot = "$KAVKASROOT/$mailer";

		my %this = %{$installedproducts{$mailer}};

		# Is our product installed first or alone?
		if ( $this{1}{"PRODUCT"} eq "KAV" )
		{
			if ( $this{2} && $this{2}{"PRODUCT"} eq "KAS" )
			{
				# The product was installed first, and KAS has been installed later
				check_and_restore_files ($AI{"NAME"}, "$proot/2", "$proot/1", @{$this{2}{"FILE"}});

				klinstall::exec_cmd_safe ("rm", "-rf", "$proot/1", "$proot/2");
				klinstall::exec_cmd ($this{2}{"RECONFIGURE"})
			}
			else
			{
				# The product was installed alone
				check_and_restore_files ($AI{"NAME"}, "$proot/1", "$proot/1", @{$this{1}{"FILE"}});
				`rm -rf $proot/1`;
			}
		}
		elsif ( $this{2}{"PRODUCT"} eq "KAV" )
		{
				# The product was installed second after KAS
				check_and_restore_files ($AI{"NAME"}, "$proot/$mailer/2", "$proot/1", @{$this{1}{"FILE"}});
				klinstall::exec_cmd_safe ("rm", "-rf", "$proot/$mailer/2");
		}
	}

	# If the directory is not empty, it won't be removed anyway
	rmdir ("$KAVKASROOT/s");
	rmdir ("$KAVKASROOT/q");
	rmdir ("$KAVKASROOT/e");
	rmdir ("$KAVKASROOT/p");

	# Remove the AV bases backup directory
	my %conf = klinstall::load_ini_file ($AI{"DEFAULT_CONFIG"});
	my $bpath = klinstall::get_ini_value (\%conf, "updater.path", "BackUpPath");

	system ("rm -f $bpath/*") if $bpath && -d $bpath && -f "$bpath/avp.set";
}

__DATA__
INSTROOT=/opt/kav/5.5/kav4unix
