/*  
 * $Id: cache.h,v 1.6 2005/02/03 17:52:31 isv Exp $
 *
 * This source file is a part of a Kaspersky Antivirus Monitor.
 * Copyright (C) Kaspersky Lab, 1997-2004
 * See License.txt for details
 *
 */

#ifndef KAVMON_CACHE_H
#define KAVMON_CACHE_H


typedef struct {
	file_info		file;
	unsigned int		count;
	struct list_head	list;
} cache_entry;


void	Monitor_cache_init(int max_files);
void	Monitor_cache_finit(void);
void	Monitor_cache_add(const file_info * file);
void	Monitor_cache_del(const file_info * file);
int	Monitor_cached(const file_info * file);


#endif
