/* $Id: monitor.h,v 1.1 2005/05/30 10:44:22 tim Exp $ */

#ifndef __MONITOR__
#define __MONITOR__
/* The module <-> monitor interface version */
#define MONITOR_INTERFACE_VERSION		10

enum monitor_filestat_type {
	MONITOR_ACCESS_ACCEPT,
	MONITOR_ACCESS_DENY
};


enum monitor_register_type {
	MONITOR_REG_OK,
	MONITOR_REG_DENY,
	MONITOR_NOT_FOUND
};



/* kernel module config params on MONITOR_CONFIG_CMD ioctl */

typedef struct {
	int exec_network_prot;
	int exec_stack_prot;
	char ** exec_net_excludes;
	char ** exec_stack_excludes;	
} exploit_config_ioctl;


typedef struct {
    int		cache_size;
} monitor_config_ioctl;
    
/* monitor ioctl commands (for kernel module only) */
#define MONITOR_REGISTER_CMD	0x10
#define MONITOR_GROUP_CMD	0x11

#if defined(__linux__)
#define EXPLOIT_CONFIG_CMD	0x20
#define MONITOR_CONFIG_CMD	0x21
#else
#define EXPLOIT_CONFIG_CMD      _IOW('B', 0x20, exploit_config_ioctl)
#define MONITOR_CONFIG_CMD      _IOW('B', 0x21, monitor_config_ioctl)
#define KAVMON_DEVICE_MAJOR	207
#endif

#ifndef __KERNEL__
typedef struct {
	int	version;
	int	module_installed;
	int	monitor_installed;
	int	exploit_installed;

	int	monitor_major;
	int	monitor_minor;

	int	exploit_major;
	int	exploit_minor;
} module_config;

#define KAVMON_DEVICE	"/dev/kavmonitor"
#define KAVEXP_DEVICE	"/dev/kavexploit"
#define MINORBITS       8
#define MKDEV(ma,mi)    (((ma) << MINORBITS) | (mi))

#ifdef __linux__
#define KAVMON_PROC	"/proc/kavmonitor"
#else
#define KAVMON_PROC	"/dev/kavinfo"
#endif
#endif

#endif /* MONITOR_H */
